//============================================================================
//  axpsi2xs.pas
//
//  AXP-SI21/AXP-SI22
//
//  Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//  V1.00 Date 1999/06/08
//
//   ̃\[Xɂ AXP-SI21 ܂ AXP-SI22 CH1CH2ڑ
//   J[hCH1瑗MACH2MႪLqĂ܂B
//   ̗łCH1COM3ACH2COM4Ɋ蓖ĂĂ̂Ƃ
//   vOLqĂ܂B
//
//============================================================================
unit axpsi2xs;

interface

uses
  Windows, Messages, SysUtils, Forms, Classes, Controls, StdCtrls;

const
  //-------------------------------------------------------------------------
  //  װԍ
  //-------------------------------------------------------------------------
  AXPSI2X_ERR_NO_COMDEV = 1;      // COM޲܂
  AXPSI2X_ERR_INIT = 2;           // װł
  AXPSI2X_ERR_SEND = 3;           // Mװł
  AXPSI2X_ERR_RECV = 4;           // Mװł

  //-------------------------------------------------------------------------
  //  ٖްzւ̲ޯԍ
  //-------------------------------------------------------------------------
  AXPSI2X_CH1 = 0;
  AXPSI2X_CH2 = 1;

  //-------------------------------------------------------------------------
  //  ۰ٕϐ
  //-------------------------------------------------------------------------
  szTitle = 'Sample';             // үޯٕ
  szSend  = 'PLUG MAGIC';         // M
                                  // COM߰޲
  szComName: array[0..1] of PChar = ( 'COM3', 'COM4' );

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    szRecv: array[0..128] of Char;
    procedure ResultMessage(szBuf: String);
    procedure ErrorMessage(dwCh, dwErrorNum: DWORD);
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

//============================================================================
//  ۸т̊Jn
//============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  hCom:       array[0..1] of THandle;
  szBuf:      String;
  dwCh:       DWORD;
  dcb:        TDCB;
  dwNumWrite: DWORD;
  dwNumRead:  DWORD;
  timeouts:   COMMTIMEOUTS;
  success:    BOOL;
begin
  for dwCh := AXPSI2X_CH1 to AXPSI2X_CH2 do begin
    //-------------------------------------------------
    // COM߰Ă
    //-------------------------------------------------
    hCom[dwCh] := CreateFile(szComName[dwCh],
                             GENERIC_READ or GENERIC_WRITE,
                             0,
                             nil,
                             OPEN_EXISTING,
                             FILE_ATTRIBUTE_NORMAL,
                             0);
    if INVALID_HANDLE_VALUE = hCom[dwCh] then begin
      ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
      Exit;
    end;
    //-------------------------------------------------
    // COM߰Ă̒ʐMݒs
    //-------------------------------------------------
    success := GetCommState(hCom[dwCh], dcb);
    if FALSE = success then begin
      ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
      Exit;
    end;
    with dcb do begin
      BaudRate := 9600;             // ްڰ:         9600bps
      ByteSize := 8;                // ް:         8ޯ
      Parity := NOPARITY;           // è:          
      StopBits := ONESTOPBIT;       // įޯ:      1ޯ
    end;
    success := SetCommState(hCom[dwCh], dcb);
    if FALSE = success then begin
      ErrorMessage(dwCh,AXPSI2X_ERR_NO_COMDEV);
      Exit;
    end;
    //-------------------------------------------------
    // COM߰ĂѱĐݒs
    //-------------------------------------------------
    with timeouts do begin
      ReadIntervalTimeout := MAXDWORD;
      ReadTotalTimeoutMultiplier := 100;
      ReadTotalTimeoutConstant := 1000;
      WriteTotalTimeoutMultiplier := 100;
      WriteTotalTimeoutConstant := 1000;
    end;
    SetCommTimeouts(hCom[dwCh], timeouts);
  end;
  //-------------------------------------------------
  // CH1當𑗐M
  //-------------------------------------------------
  szBuf := Format('%s'#10#10 +
                  'Send: %s',
                  [szComName[AXPSI2X_CH1],szSend]);
  ResultMessage(szBuf);
  WriteFile(hCom[AXPSI2X_CH1],szSend,strlen(szSend),dwNumWrite,nil);
  if dwNumWrite <> strlen(szSend) then begin
    ErrorMessage(AXPSI2X_CH1,AXPSI2X_ERR_SEND);
    Exit;
  end;
  //-------------------------------------------------
  // CH2當M
  //-------------------------------------------------
  ReadFile(hCom[AXPSI2X_CH2],szRecv,dwNumWrite,dwNumRead,nil);
  if dwNumRead <> strlen(szSend) then begin
    ErrorMessage(AXPSI2X_CH2,AXPSI2X_ERR_RECV);
    Exit;
  end;
  szRecv[dwNumRead] := #0;
  szBuf := Format('%s'#10#10 +
                  'Reseived: %s',
                  [szComName[AXPSI2X_CH2],szRecv]);
  ResultMessage(szBuf);
  //-------------------------------------------------
  // COM߰Ă۰ނ
  //-------------------------------------------------
  for dwCh := AXPSI2X_CH1 to AXPSI2X_CH2 do
    CloseHandle(hCom[dwCh]);
  ResultMessage('AXP-SI2X'#10#10'Success');
  Exit;
end;

//============================================================================
// ʂ\
//============================================================================
procedure TForm1.ResultMessage(szBuf: String);
begin
  Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//============================================================================
// װүނ\
//============================================================================
procedure TForm1.ErrorMessage(dwCh, dwErrorNum: DWORD);
var
  szBuf: String;
begin
  case dwErrorNum of
    AXPSI2X_ERR_NO_COMDEV:
      szBuf := Format('Ch%d'#09' COM open error'#10#10'Error code: %08xH', [dwCh,GetLastError()]);
    AXPSI2X_ERR_INIT:
      szBuf := Format('Ch%d'#09' COM initialize error', [dwCh]);
    AXPSI2X_ERR_SEND:
      szBuf := Format('Ch%d'#09' COM send error', [dwCh]);
    AXPSI2X_ERR_RECV:
      szBuf := Format('Ch%d'#09' COM receive error', [dwCh]);
  end;
  Application.MessageBox(PChar(szBuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

